import { AnyRouter, Maybe, inferRouterError } from '@trpc/server';
import { TRPCErrorResponse } from '@trpc/server/rpc';
export interface TRPCClientErrorLike<TRouter extends AnyRouter> {
    readonly message: string;
    readonly shape: Maybe<inferRouterError<TRouter>>;
    readonly data: Maybe<inferRouterError<TRouter>['data']>;
}
export declare class TRPCClientError<TRouter extends AnyRouter> extends Error implements TRPCClientErrorLike<TRouter> {
    readonly cause: Maybe<Error>;
    readonly shape: Maybe<inferRouterError<TRouter>>;
    readonly data: Maybe<inferRouterError<TRouter>['data']>;
    readonly meta: Record<string, unknown> | undefined;
    constructor(message: string, opts?: {
        result: Maybe<TRPCErrorResponse<inferRouterError<TRouter>>>;
        cause?: Maybe<Error>;
        meta?: Record<string, unknown>;
    });
    static from<TRouter extends AnyRouter>(cause: Error | TRPCErrorResponse<any>, opts?: {
        meta?: Record<string, unknown>;
    }): TRPCClientError<TRouter>;
}
//# sourceMappingURL=TRPCClientError.d.ts.map