import { ProcedureType } from '@trpc/server';
import { PromiseAndCancel, TRPCClientRuntime } from '../types';
export interface HTTPLinkOptions {
    url: string;
}
export interface ResponseShape {
    json: unknown;
    meta: {
        response: Response;
    };
}
declare type GetInputOptions = {
    runtime: TRPCClientRuntime;
} & ({
    inputs: unknown[];
} | {
    input: unknown;
});
export declare type HTTPRequestOptions = HTTPLinkOptions & GetInputOptions & {
    type: ProcedureType;
    path: string;
};
export declare function getUrl(opts: HTTPRequestOptions): string;
declare type GetBodyOptions = {
    type: ProcedureType;
} & GetInputOptions;
export declare function getBody(opts: GetBodyOptions): string | undefined;
export declare function httpRequest(opts: HTTPRequestOptions): PromiseAndCancel<ResponseShape>;
export {};
//# sourceMappingURL=httpUtils.d.ts.map