import { AnyRouter } from '@trpc/server';
import { TRPCResultMessage } from '@trpc/server/rpc';
import { TRPCClientRuntime } from '..';
import { TRPCClientError } from '../../TRPCClientError';
import { OperationResult } from '../types';
/** @internal */
export declare function transformOperationResult<TRouter extends AnyRouter, TOutput>(result: OperationResult<TRouter, TOutput>, runtime: TRPCClientRuntime): {
    readonly ok: false;
    readonly error: TRPCClientError<TRouter>;
    readonly context: import("..").OperationContext | undefined;
    readonly data?: undefined;
} | {
    readonly ok: true;
    readonly data: TOutput;
    readonly context: import("..").OperationContext | undefined;
    readonly error?: undefined;
};
/** @internal */
export declare function transformSubscriptionOperationResult<TRouter extends AnyRouter, TOutput>(result: OperationResult<TRouter, TOutput>, runtime: TRPCClientRuntime): {
    readonly ok: false;
    readonly error: TRPCClientError<TRouter>;
    readonly context: import("..").OperationContext | undefined;
    readonly data?: undefined;
} | {
    readonly ok: true;
    readonly data: TRPCResultMessage<TOutput>;
    readonly context: import("..").OperationContext | undefined;
    readonly error?: undefined;
};
//# sourceMappingURL=transformOperationResult.d.ts.map