import { AnyRouter } from '@trpc/server';
import { UnsubscribeFn } from '@trpc/server/observable';
import { retryDelay } from '../internals/retryDelay';
import { Operation, OperationResultObserver, TRPCLink } from './types';
export interface WebSocketClientOptions {
    url: string;
    WebSocket?: WebSocket;
    retryDelayMs?: typeof retryDelay;
}
export declare function createWSClient(opts: WebSocketClientOptions): {
    close: () => void;
    request: (op: Operation, callbacks: OperationResultObserver<AnyRouter<any>, unknown>) => UnsubscribeFn;
    getConnection(): WebSocket;
};
export declare type TRPCWebSocketClient = ReturnType<typeof createWSClient>;
export interface WebSocketLinkOptions {
    client: TRPCWebSocketClient;
}
export declare function wsLink<TRouter extends AnyRouter>(opts: WebSocketLinkOptions): TRPCLink<TRouter>;
//# sourceMappingURL=wsLink.d.ts.map